changequote({{,}})
dnl Definir la liste des lib, nom et chemin
define(__listLib__,{{dnl
__lib__({{lang}})
__lib__({{util}})
}})

MYCODEDIR :=src
INCDIR :=-Iinclude
LIBDIR :=-Llib -L/usr/local/lib
LIBS :=-lm $(LIBS)

ifeq ($(DEBUG),1)
INCDIR+= -DDEBUG=1
endif

# makemake variables
DEPENDFLAGS := -Wall ${OPTIONS}

# C preprocessor (C, C++, FORTRAN)
CPPFLAGS = ${INCDIR} -O3

# C compiler
CC     := gcc
CFLAGS  = ${DEPENDFLAGS}
%.o : %.c
	${CC} ${CPPFLAGS} ${CFLAGS} -c $< -o $@

# C++ compiler
CXX      := g++
CXXFLAGS  = ${DEPENDFLAGS}
%.o : %.cc
	${CXX} ${CPPFLAGS} ${CXXFLAGS} -c $< -o $@
%.o : %.cc
	${CXX} ${CPPFLAGS} ${CXXFLAGS} -c $< -o $@
%.o : %.C
	${CXX} ${CPPFLAGS} ${CXXFLAGS} -c $< -o $@
%.o : %.cpp
	${CXX} ${CPPFLAGS} ${CXXFLAGS} -c $< -o $@
%.o :%.cxx
	${CXX} ${CPPFLAGS} ${CXXFLAGS} -c $< -o $@

# C pre processing
PREPROCESSOR:=gcc -E
PPFLAGS:=-x c -P ${INCDIR}

# C++ linker
LINKER    := g++
LDFLAGS    = 
LOADLIBES := ${LIBDIR} ${LIBS}
LINK:=${LINKER} ${LOADLIBES}

# Library archive
ARCH:=ar
ARCHFLAGS:=-rsc

define({{__lib__}},{{lib/libnaja.$1.so \}})dnl
all: \
__listLib__	bin/test

Makefile: Makefile.m4
	m4 $^ > $@

clean:
	rm -f lib/* ; \
	find src -name '*.o' -exec rm -f {} \;
	
dist:
	cd .. ; \
	tar -cvzf naja.tgz `find naja -name '*.[hc][hc]'` naja/configure naja/Makefile.m4 naja/COPYING naja/ChangeLog
	
undefine({{__lib__}}) dnl
dnl generer ce qu'il faut de makefile pour
dnl une lib
dnl $1 nom de la lib
define({{__lib__}},{{
lib_$1_obj:=$(patsubst %.cc,%.o,$(wildcard src/$(subst .,/,$1)/*.cc))
lib/libnaja.$1.so: ${lib_$1_obj}
	${LINK} -o lib/libnaja.$1.so -shared $^ 

}})

__listLib__

/usr/local/lib/%.so: lib/%.so
	cp $^ $@ ; chmod 755 $@

undefine({{__lib__}})
dnl Installation des lib
define({{__lib__}},{{dnl
	/usr/local/lib/libnaja.$1.so \dnl
}})

bin/test: src/test.o
	${LINK} -lnaja.lang -lnaja.util -o bin/test $^

install:\
__listLib__
