/* $Id: naja.hh,v 1.1 2002/04/27 13:04:04 sdevaux Exp $
 *
 * NaJA
 * Tabs = 4 chars
 * copyright (C) 2002 Sebastien Devaux
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
 *
 *              Sebastien Devaux <sebastien.devaux@laposte.net>
 */ 
#ifndef __najapi_hh__
#define __najapi_hh__

#include <iostream.h>


class Debug {
public:
	static int indent;
	static char indentChar;
	static void printIndent(ostream * out);
};

#ifdef DEBUG
#	define TRACE(message) \
		Debug::printIndent(&cerr); \
		cerr <<"> "<< __FILE__ << ":" << __LINE__ << endl; \
		Debug::printIndent(&cerr); \
		cerr <<"  "<< message << endl; 
#	define DBUG(message) TRACE(message)
#	define MSTART(message) \
		Debug::indent++; \
		DBUG(this<<"/"<<message)
#	define SMSTART(message) \
		Debug::indent++; \
		DBUG("static "<<message)
#	define MEND \
		DBUG("Done.") \
		Debug::indent--;
#	define MRETURN(retValue) \
		MEND \
		return retValue;
#else
#	define TRACE(message) \
		cerr << __FILE__ << ":" << __LINE__ \
			<< ":" << message << endl;
#	define DBUG(message)
#	define MSTART(message)
#	define SMSTART(message)
#	define MEND
#	define MRETURN(retValue) return retValue;
#endif // DEBUG

typedef int boolean;
#define false 0
#define true  -1


#ifdef DECL_NAMESPACE
#	define PACKAGE_BEGIN(package) namespace package {
#	define PACKAGE_END	}
#	define PACKAGE_USE(package) use namespace package;
#else
#	define PACKAGE_BEGIN(package)
#	define PACKAGE_END
#	define PACKAGE_USE(package)
#endif


#include "lang/NajaRef.hh"
#include "lang/Object.hh"

#endif // __najapi_hh__

